org.apache.storm.elasticsearch.bolt

## Class EsPercolateBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.topology.base.BaseTickTupleAwareRichBolt
      - - org.apache.storm.elasticsearch.bolt.AbstractEsBolt
        - - org.apache.storm.elasticsearch.bolt.EsPercolateBolt

- All Implemented Interfaces:
    Serializable, IBolt, IComponent, IRichBolt

      public class EsPercolateBolt
      extends AbstractEsBolt

  Basic bolt for retrieve matched percolate queries.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.storm.elasticsearch.bolt.AbstractEsBolt

      `client, collector, objectMapper`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EsPercolateBolt(EsConfig esConfig)` EsPercolateBolt constructor.
    `EsPercolateBolt(EsConfig esConfig, EsTupleMapper tupleMapper)` EsPercolateBolt constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `declareOutputFields(OutputFieldsDeclarer outputFieldsDeclarer)` Declare the output schema for all the streams of this topology.
    `void` | `prepare(Map<String,Object> map, TopologyContext topologyContext, OutputCollector outputCollector)` Called when a task for this component is initialized within a worker on the cluster.
    `void` | `process(Tuple tuple)` Process a single non-tick tuple of input.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseTickTupleAwareRichBolt

      `execute, onTickTuple`

    - ### Methods inherited from class org.apache.storm.topology.base.BaseRichBolt

      `cleanup`

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `getComponentConfiguration`

- - ### Constructor Detail

    - #### EsPercolateBolt

          public EsPercolateBolt(EsConfig esConfig)

      EsPercolateBolt constructor.

      Parameters:
        `esConfig` - Elasticsearch configuration containing node addresses `EsConfig`

    - #### EsPercolateBolt

          public EsPercolateBolt(EsConfig esConfig,
                                 EsTupleMapper tupleMapper)

      EsPercolateBolt constructor.

      Parameters:
        `esConfig` - Elasticsearch configuration containing node addresses and cluster name `EsConfig`
        `tupleMapper` - Tuple to ES document mapper `EsTupleMapper`

  - ### Method Detail

    - #### prepare

          public void prepare(Map<String,Object> map,
                              TopologyContext topologyContext,
                              OutputCollector outputCollector)

      Description copied from interface: `IBolt`

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Specified by:
        `prepare` in interface `IBolt`
      Overrides:
        `prepare` in class `AbstractEsBolt`
      Parameters:
        `map` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `topologyContext` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `outputCollector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### process

          public void process(Tuple tuple)

      Process a single non-tick tuple of input. Implementation needs to handle ack manually. More details on `IBolt.execute(Tuple)`.

      Tuple should have relevant fields (source, index, type) for storeMapper to extract ES document.
      If there exists non-empty percolate response, EsPercolateBolt will emit tuple with original source and Percolate.Match for each Percolate.Match in PercolateResponse.
      Specified by:
        `process` in class `BaseTickTupleAwareRichBolt`
      Parameters:
        `tuple` - The input tuple to be processed.

    - #### declareOutputFields

          public void declareOutputFields(OutputFieldsDeclarer outputFieldsDeclarer)

      Description copied from interface: `IComponent`

      Declare the output schema for all the streams of this topology.

      Specified by:
        `declareOutputFields` in interface `IComponent`
      Overrides:
        `declareOutputFields` in class `AbstractEsBolt`
      Parameters:
        `outputFieldsDeclarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

Copyright © 2021 The Apache Software Foundation. All rights reserved.